import java.io.*;
import java.util.*;

/**  CSC 263/B63 Assignment #1 Programming component
 * Provides command line access to the AVL tree class
 *
 * This file has been provided to make it easier to test your AVL tree code.
 *
 * DO NOT SUBMIT THIS FILE
 **/

public class Tester{

  	
  public static void main(String[] args) throws IOException{
  int t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17;
  t1=t2=t3=t4=t5=t6=t7=t8=t9=t10=t11=t12=t13=t14=t15=t16=t17=0;
  
  t1 = test1();  
  t2 = 2*test2();
  t3 = 2*test3();
  t4 = test4();
  t5 = 2*test5();
  t6 = 2*test6();
  t7 = test7();
  t8 = test8();
  t9 = test9();
  t10 = test10();
  t11 = test11();
  t12 = test12();
  t13 = test13();
  t14 = test14();
  t15 = test15();
  t16 = test16();
  t17 = 5*test17();
  
  System.out.println("*Insert, SL rotation: \t\t"+t1+"/1");	
  System.out.println("*Insert, DRL rotation, C + : \t"+t2+"/2");	
  System.out.println("*Insert, DRL rotation, C - : \t"+t3+"/2");	
  System.out.println("*Insert, SR rotation: \t\t"+t4+"/1");	
  System.out.println("*Insert, DLR rotation, C + : \t"+t5+"/2");	
  System.out.println("*Insert, DLR rotation, C - : \t"+t6+"/2");	
  System.out.println("*Delete, SR rotation, B - : \t"+t7+"/1");	
  System.out.println("*Delete, SR rotation, B 0 : \t"+t8+"/1");	
  System.out.println("*Delete, DLR rotation, C - : \t"+t9+"/1");	
  System.out.println("*Delete, DLR rotation, C 0 : \t"+t10+"/1");	
  System.out.println("*Delete, DLR rotation, C + : \t"+t11+"/1");	
  System.out.println("*Delete, SL rotation, B 0 : \t"+t12+"/1");	
  System.out.println("*Delete, SL rotation, B + : \t"+t13+"/1");	
  System.out.println("*Delete, DRL rotation, C - : \t"+t14+"/1");	
  System.out.println("*Delete, DRL rotation, C 0 : \t"+t15+"/1");	
  System.out.println("*Delete, DRL rotation, C + : \t"+t16+"/1");	
  System.out.println("*Multiple Inserts/Deletes:\t "+t17+"/5");

  int total = t1 + t2 + t3 + t4 + t5 + t6 + t7 + t8+
	  t9 + t10 + t11 + t12 + t13 + t14 + t15 + t16 + t17;
  System.out.println("**Total:\t\t\t\t"+total+"/25");
  }

  // Test Insert:  SL rotation
  public static int test1()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(9,0,1);
	  t.BSTinsert(6,0,-1);
	  t.BSTinsert(16,0,0);
	  t.BSTinsert(2,0,0);
	  t.BSTinsert(13,0,-1);
	  t.BSTinsert(20,0,0);
	  t.BSTinsert(12,0,0);
	  t.BSTinsert(18,0,0);
	  t.BSTinsert(30,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST1: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST1: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }

	  System.out.println("Test 1:Testing insert with single left rotation.\nBefore:"); 
	  t.print();
	  try{

	        t.insert(35,0);
	        System.out.println("After inserting 35:"); 
	        t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(35);
			return 1;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  System.out.println("ERROR: Test1 did not insert element 35");
		  t.print();
		  return 0;
	  }catch(Exception e){
                System.out.println("ERROR: Test1threw an exception.");
		t.print();
		return 0;
        }
  }

  // Test Insert:  DRL rotation, C is -
  public static int test2()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(9,0,1);
	  t.BSTinsert(6,0,-1);
	  t.BSTinsert(16,0,0);
	  t.BSTinsert(2,0,0);
	  t.BSTinsert(13,0,0);
	  t.BSTinsert(20,0,0);
	  t.BSTinsert(12,0,0);
	  t.BSTinsert(14,0,0);
	  t.BSTinsert(18,0,0);
	  t.BSTinsert(30,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST2: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST2: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }

	  System.out.println("Test 2:Testing insert with double right-left rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.insert(11,0);
	        System.out.println("After inserting 11:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(11);
			return 1;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  System.out.println("ERROR: Test2 did not insert element 11");
		  t.print();
		  return 0;
	  }catch(Exception e){
                System.out.println("ERROR: Test2 threw an exception.");
		t.print();
		return 0;
        }
  }

  // Test Insert:  DRL rotation, C is -
  public static int test3()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(9,0,1);
	  t.BSTinsert(6,0,-1);
	  t.BSTinsert(16,0,0);
	  t.BSTinsert(2,0,0);
	  t.BSTinsert(13,0,0);
	  t.BSTinsert(20,0,0);
	  t.BSTinsert(12,0,0);
	  t.BSTinsert(14,0,0);
	  t.BSTinsert(18,0,0);
	  t.BSTinsert(30,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST3: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST3: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }

	  System.out.println("Test 3: Testing insert with double right-left rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.insert(15,0);
	  	System.out.println("After inserting 15:"); 
	        t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(15);
			return 1;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  System.out.println("ERROR: Test3 did not insert element 15");
		  t.print();
		  return 0;
	  }catch(Exception e){
                System.out.println("ERROR: Test3 threw an exception.");
		t.print();
		return 0;
        }
  }

  // Test Insert:  SR rotation
  public static int test4()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(20,0,-1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(27,0,1);
	  t.BSTinsert(5,0,0);
	  t.BSTinsert(13,0,1);
	  t.BSTinsert(30,0,0);
	  t.BSTinsert(3,0,0);
	  t.BSTinsert(6,0,0);
	  t.BSTinsert(15,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST4: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST4: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 4: Testing insert with single right rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.insert(1,0);
	        System.out.println("After inserting 1");
	        t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(1);
			return 1;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  System.out.println("ERROR: Test4 did not insert element 1");
		  t.print();
		  return 0;
	  }catch(Exception e){
                System.out.println("ERROR: Test4 threw an exception.");
		t.print();
		return 0;
        }
  }

  // Test Insert:  DLR rotation, C is +
  public static int test5()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(20,0,-1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(27,0,1);
	  t.BSTinsert(5,0,0);
	  t.BSTinsert(13,0,0);
	  t.BSTinsert(30,0,0);
	  t.BSTinsert(3,0,0);
	  t.BSTinsert(6,0,0);
	  t.BSTinsert(12,0,0);
	  t.BSTinsert(15,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST5: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST5: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 5: Testing insert with double left-right rotation.\nBefore:"); 
	  t.print();



	  try{
	        t.insert(16,0);
		System.out.println("After inserting 16");
		t.print();
		
	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(16);
			return 1;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  System.out.println("ERROR: Test5 did not insert element 16");
		  t.print();
		  return 0;
	  }catch(Exception e){
                System.out.println("ERROR: Test5 threw an exception.");
		t.print();
		return 0;
        }
  }
  
  // Test Insert:  DLR rotation, C is -
  public static int test6()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(20,0,-1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(27,0,1);
	  t.BSTinsert(5,0,0);
	  t.BSTinsert(13,0,0);
	  t.BSTinsert(30,0,0);
	  t.BSTinsert(3,0,0);
	  t.BSTinsert(6,0,0);
	  t.BSTinsert(12,0,0);
	  t.BSTinsert(15,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST6: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST6: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }

	  System.out.println("Test 6:Testing insert with double left-right rotation.\nBefore:"); 
	  t.print();
	  
	  try{
	        t.insert(11,0);
		System.out.println("After inserting element 11:");
	        t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(11);
			return 1;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  System.out.println("ERROR: Test6 did not insert element 11");
		  t.print();
		  return 0;
	  }catch(Exception e){
                System.out.println("ERROR: Test6 threw an exception.");
		t.print();
		return 0;
        }
  }

  // Test Delete:  SR rotation, B is -
  public static int test7()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(40,0,-1);
	  t.BSTinsert(30,0,-1);
	  t.BSTinsert(60,0,+1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(35,0,0);
	  t.BSTinsert(100,0,0);
	  t.BSTinsert(5,0,0);
	  t.BSTinsert(15,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST7: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST7: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 7: Testing delete with single right rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.deleteKey(100);
		System.out.println("After deleting element 100:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(100);
			System.out.println("ERROR: Test7 element 100 was not deleted.");
			return 0;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  return 1;
	  }catch(Exception e){
                System.out.println("ERROR: Test7 threw an exception.");
		t.print();
		return 0;
        }
  }

  // Test Delete:  SR rotation, B is 0
  public static int test8()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(40,0,-1);
	  t.BSTinsert(30,0,0);
	  t.BSTinsert(60,0,+1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(35,0,+1);
	  t.BSTinsert(100,0,0);
	  t.BSTinsert(5,0,0);
	  t.BSTinsert(15,0,0);
	  t.BSTinsert(37,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST8: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST8: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 8: Testing delete with single right rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.deleteKey(100);
		System.out.println("After deleting element 100:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(100);
			System.out.println("ERROR: Test8 element 100 was not deleted.");
			return 0;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  return 1;
	  }catch(Exception e){
                System.out.println("ERROR: Test8 threw an exception.");
		t.print();
		return 0;
        }
  }

  // Test Delete:  DLR rotation, C is - 
  public static int test9()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(40,0,-1);
	  t.BSTinsert(30,0,+1);
	  t.BSTinsert(60,0,+1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(35,0,-1);
	  t.BSTinsert(100,0,0);
	  t.BSTinsert(31,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST9: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST9: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 9: Testing delete with double left-right rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.deleteKey(100);
		System.out.println("After deleting element 100:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(100);
			System.out.println("ERROR: Test9 element 100 was not deleted.");
			return 0;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  return 1;
	  }catch(Exception e){
                System.out.println("ERROR: Test9 threw an exception.");
		t.print();
		return 0;
        }
  }


  // Test Delete:  DLR rotation, C is 0 
  public static int test10()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(40,0,-1);
	  t.BSTinsert(30,0,+1);
	  t.BSTinsert(60,0,+1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(35,0,0);
	  t.BSTinsert(100,0,0);
	  t.BSTinsert(31,0,0);
	  t.BSTinsert(37,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST10: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST10: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 10: Testing delete with double left-right rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.deleteKey(100);
		System.out.println("After deleting element 100:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(100);
			System.out.println("ERROR: Test10 element 100 was not deleted.");
			return 0;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  return 1;
	  }catch(Exception e){
                System.out.println("ERROR: Test10 threw an exception.");
		t.print();
		return 0;
        }
  }



  // Test Delete:  DLR rotation, C is + 
  public static int test11()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(40,0,-1);
	  t.BSTinsert(30,0,+1);
	  t.BSTinsert(60,0,+1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(35,0,+1);
	  t.BSTinsert(100,0,0);
	  t.BSTinsert(37,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST11: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST11: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 11: Testing delete with double left-right rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.deleteKey(100);
		System.out.println("After deleting element 100:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(100);
			System.out.println("ERROR: Test11 element 100 was not deleted.");
			return 0;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  return 1;
	  }catch(Exception e){
                System.out.println("ERROR: Test11 threw an exception.");
		t.print();
		return 0;
        }
  }




  // Test Delete:  SL rotation, B is 0 
  public static int test12()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(40,0,+1);
	  t.BSTinsert(30,0,-1);
	  t.BSTinsert(60,0,0);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(50,0,+1);
	  t.BSTinsert(70,0,0);
	  t.BSTinsert(55,0,0);
	  t.BSTinsert(65,0,0);
	  t.BSTinsert(80,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST12: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST12: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 12: Testing delete with single left rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.deleteKey(10);
		System.out.println("After deleting element 10:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(10);
			System.out.println("ERROR: Test12 element 10 was not deleted.");
			return 0;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  return 1;
	  }catch(Exception e){
                System.out.println("ERROR: Test12 threw an exception.");
		t.print();
		return 0;
        }
  }


  // Test Delete:  SL rotation, B is + 
  public static int test13()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(40,0,+1);
	  t.BSTinsert(30,0,-1);
	  t.BSTinsert(60,0,+1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(50,0,0);
	  t.BSTinsert(70,0,0);
	  t.BSTinsert(65,0,0);
	  t.BSTinsert(80,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST13: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST13: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 13: Testing delete with single left rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.deleteKey(10);
		System.out.println("After deleting element 10:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(10);
			System.out.println("ERROR: Test13 element 10 was not deleted.");
			return 0;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  return 1;
	  }catch(Exception e){
                System.out.println("ERROR: Test13 threw an exception.");
		t.print();
		return 0;
        }
  }

  // Test Delete:  DRL rotation, C is - 
  public static int test14()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(40,0,+1);
	  t.BSTinsert(30,0,-1);
	  t.BSTinsert(60,0,-1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(50,0,-1);
	  t.BSTinsert(70,0,0);
	  t.BSTinsert(45,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST14: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST14: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 14: Testing delete with double right-left rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.deleteKey(10);
		System.out.println("After deleting element 10:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(10);
			System.out.println("ERROR: Test14 element 10 was not deleted.");
			return 0;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  return 1;
	  }catch(Exception e){
                System.out.println("ERROR: Test14 threw an exception.");
		t.print();
		return 0;
        }
  }



  // Test Delete:  DRL rotation, C is 0 
  public static int test15()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(40,0,+1);
	  t.BSTinsert(30,0,-1);
	  t.BSTinsert(60,0,-1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(50,0,0);
	  t.BSTinsert(70,0,0);
	  t.BSTinsert(45,0,0);
	  t.BSTinsert(55,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST15: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST15: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 15: Testing delete with double right-left rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.deleteKey(10);
		System.out.println("After deleting element 10:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(10);
			System.out.println("ERROR: Test15 element 10 was not deleted.");
			return 0;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  return 1;
	  }catch(Exception e){
                System.out.println("ERROR: Test15 threw an exception.");
		t.print();
		return 0;
        }
  }


  // Test Delete:  DRL rotation, C is 0 
  public static int test16()
  {
	  AVLTestTree t = new AVLTestTree();
	  
	  t.BSTinsert(40,0,+1);
	  t.BSTinsert(30,0,-1);
	  t.BSTinsert(60,0,-1);
	  t.BSTinsert(10,0,0);
	  t.BSTinsert(50,0,+1);
	  t.BSTinsert(70,0,0);
	  t.BSTinsert(55,0,0);

	  if (!t.isBST())
	  {
		  System.out.println("FAILURE IN TEST16: TEST DOES NOT CONSTRUCT PROPER BST, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  if (!t.isHBalanced())
	  {
		  System.out.println("FAILURE IN TEST16: TEST DOES NOT CONSTRUCT PROPER AVL TREE, NO MARKS DEDUCTED.");
		  return 1;
	  }
	  
	  System.out.println("Test 16: Testing delete with double right-left rotation.\nBefore:"); 
	  t.print();

	  try{
	        t.deleteKey(10);
		System.out.println("After deleting element 10:");
		t.print();

	  	if (t.isBST()&&t.isHBalanced())
		  {
			t.search(10);
			System.out.println("ERROR: Test16 element 10 was not deleted.");
			return 0;
		  }	  else return 0;
	  } catch (NoSuchElementException e) {
		  return 1;
	  }catch(Exception e){
                System.out.println("ERROR: Test16 threw an exception.");
		t.print();
		return 0;
        }
  }

  public static int test17() throws IOException{

	  AVLTestTree t = new AVLTestTree();
	  int[] array = new int[1000]; 
	  

	  BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

	  for (int i=0;i<10000;++i)
	  {
              int key = Integer.parseInt(in.readLine());
	      if (i<1000) array[i]=key;
	      t.insert(key,0);
		
	      if(!t.isBST()||!t.isHBalanced())
	      {
	              in.close();
		      return 0;
	      }	      
	  }

	  in.close();

	  for (int i=0;i<1000;++i)
	  {
	      t.deleteKey(array[i]);
		
	      if(!t.isBST()||!t.isHBalanced())
	      {
		      return 0;
	      }	      
	  }
	  return 1;
	  
  }

}
